/*
    Copyright (c) 2015 digitalSTROM AG, Zurich, Switzerland

    This file is part of dS Assistant.

    dS-Assistant is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dS-Assistant is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

    NOTE: all APIs, especially the JSON API, offered by this application
          are subject to change without further notice.
*/

#ifndef __CHARGING_PULSE__
#define __CHARGING_PULSE__

#include <list>
#include <vector>

#include <boost/shared_ptr.hpp>

#include "hwdesc.h"

namespace dSA
{

typedef boost::shared_ptr<Device> device_p;
typedef std::list<device_p> devices_t;

/* device -> slot */
typedef std::pair<boost::shared_ptr<Device>, int> cp_assignment_t;
typedef std::vector<cp_assignment_t> cp_assignments_t;

/* used by unit test of sorting */
bool sortByTemperature(const boost::shared_ptr<const Device> &lhs,
                       const boost::shared_ptr<const Device> &rhs);

cp_assignments_t assignChargingPulse(const devices_t &devices);

} // namespace

#endif
