/*
    Copyright (c) 2015 digitalSTROM AG, Zurich, Switzerland

    This file is part of dS Assistant.

    dS-Assistant is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dS-Assistant is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

    NOTE: all APIs, especially the JSON API, offered by this application
          are subject to change without further notice.
*/

#ifdef HAVE_CONFIG_H
    #include "autoconfig.h"
#endif

#include <cassert>

#include "hwdesc_attributes.h"
#include "util.h"

int attributeToTemperature(uint16_t attr)
{
    // 149 - 0.9 * attr -> Celsius
    int ret = 1490 - 9 * attr;
    if (ret < MIN_TEMP) {
        return MIN_TEMP;
    }
    assert(ret <= MAX_TEMP);
    return ret;
}

const size_t charge_slot_count = dSA::array_size(charging_pulse_table);
