/*
    Copyright (c) 2010, 2011 aizo ag, Zurich, Switzerland

    Author: Sergey 'Jin' Bostandzhyan <jin@dev.digitalstrom.org>

    This file is part of dS Assistant.

    dS-Assistant is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dS-Assistant is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __DSA_JSON_WEB_HANDLER_H__
#define __DSA_JSON_WEB_HANDLER_H__

#include "web_handler.h"
#include <json.h>
#include <string>

namespace dSA
{

class JSONWebHandler : public WebHandler
{
public:
    JSONWebHandler(struct mg_connection* connection,
                   const struct mg_request_info* request_info);
    virtual void process() = 0;
protected:
    void failure(const std::string message);
    std::string http_ok();
    json_object* json_ok();
};

}; // namespace

#endif//__DSA_JSON_WEB_HANDLER_H__

